propellor-5.3.3: property-based host configuration management in haskell

Safe Haskell | Safe
Language | Haskell98

Propellor.Types.Container

Synopsis

- data Bound v = Bound {
  - hostSide :: v
  - containerSide :: v
  }
- (-<-) :: (hostv ~ v, containerv ~ v) => hostv -> containerv -> Bound v
- (->-) :: (containerv ~ v, hostv ~ v) => containerv -> hostv -> Bound v
- same :: v -> Bound v

# Documentation

data Bound v Source #

A value that can be bound between the host and a container.

For example, a Bound Port is a Port on the container that is bound to a Port on the host.

Constructors

Bound |

Fields

- hostSide :: v
- containerSide :: v

Instances

Bindable (Bound FilePath) Source # |
Methods toBind :: Bound FilePath -> String
Publishable (Bound Port) Source # |
Methods toPublish :: Bound Port -> String
Mountable (Bound FilePath) Source # |
Methods toMount :: Bound FilePath -> String
Publishable (Bound Port) Source # |
Methods toPublish :: Bound Port -> String
Publishable (Proto, Bound Port) Source # |
Methods toPublish :: (Proto, Bound Port) -> String

(-<-) :: (hostv ~ v, containerv ~ v) => hostv -> containerv -> Bound v Source #

Create a Bound value, from two different values for the host and container.

For example, `Port 8080 -<- Port 80` means that port 8080 on the host is bound to port 80 from the container.

(->-) :: (containerv ~ v, hostv ~ v) => containerv -> hostv -> Bound v Source #

Flipped version of -<- with the container value first and host value second.

same :: v -> Bound v Source #

Create a Bound value, that is the same on both the host and container.